/* Configuration for an i386 running emx (target). */

/* We do want to add an underscore to the front of each user symbol. */
#define YES_UNDERSCORES

#include "i386/gstabs.h"

/* The system headers are C++-aware. */
#define NO_IMPLICIT_EXTERN_C

/* Paths. */
#define GCC_INCLUDE_DIR            "/emx/include"
#define GPLUSPLUS_INCLUDE_DIR      "/emx/include.gpp"
#define LOCAL_INCLUDE_DIR          "/usr/local/include"
#define CROSS_INCLUDE_DIR          "/emx/include.sys"
#define STANDARD_EXEC_PREFIX       "/emx/bin/"
#define STANDARD_STARTFILE_PREFIX  "/emx/lib/"

/* Target configuration name. */
#define DEFAULT_TARGET_MACHINE     "i386-unknown-emx"

/* Enable #pragma pack. */
#define HANDLE_SYSV_PRAGMA

/* Bitfields may cross alignment boundaries. */
#undef PCC_BITFIELD_TYPE_MATTERS
#define PCC_BITFIELD_TYPE_MATTERS 0

/* By default, return short structures in registers. */
#define DEFAULT_PCC_STRUCT_RETURN 0


/* Don't continue symbols.  I think all relevant tools can handle
   symbols of arbitrary length.  GAS does not correctly handle
   continued symbols: it sometimes emits another symbol before the
   continuation. */
#define DBX_CONTIN_LENGTH 0

/* The -Zstack and -Zmap options take an argument. */
#define WORD_SWITCH_TAKES_ARG(STR) (DEFAULT_WORD_SWITCH_TAKES_ARG (STR) \
                                    || !strcmp (STR, "Zstack") \
                                    || !strcmp (STR, "Zmap"))

/* Predefine symbols `__32BIT__' and `__EMX__'.  Note: no longer
   define `i386' -- it quite likely interferes with user symbols. */
#undef CPP_PREDEFINES
#define CPP_PREDEFINES "-D__32BIT__ -D__EMX__ \
  -Asystem(unix) -Asystem(emx) -Acpu(i386) -Amachine(i386)"

/* Predefine the symbol `__MT__' for multi-threaded programs (-Zmtd or
   -Zmts).  Pass -Zc++-comments and -ZC++-comments to the
   preprocessor. */
#undef CPP_SPEC
#define CPP_SPEC "%{posix:-D_POSIX_SOURCE} %{Zmtd:-D__MT__} %{Zmts:-D__MT__} %{Zomf} %{ZC++-comments} %{Zc++-comments}"


#define ASM_FINAL_SPEC "%{Zomf:\n emxomf %{s} %{c:%W{o*}%{!o*:-o %w%b.obj}}\
                                         %{!c:-o %d%w%b.obj} %g.o}"

#define STARTFILE_SPEC \
  "%{Zomf:%{Zdll:dll0.obj%s}%{!Zdll:crt0.obj%s}}" \
  "%{!Zomf:%{Zdll:dll0.o%s}" \
          "%{!Zdll:%{pg:gcrt0.o%s}%{!pg:%{p:mcrt0.o%s}%{!p:crt0.o%s}}}}"

#define LIB_SPEC \
  "%{g*:-lg} %{!p:%{!pg:%{!Zmts:-lc}%{Zmts:-lcmt}}}%{p:-lc_p}%{pg:-lc_p}"

/* Register allocation (override config/i386/i386.h) */
#undef REG_ALLOC_ORDER
#define REG_ALLOC_ORDER \
/*ax,dx,cx,bx,si,di,bp,sp,st,st1,st2,st3,st4,st5,st6,st7,arg*/ \
{  0, 1, 2, 3, 4, 5, 6, 7, 8,  9, 10, 11, 12, 13, 14, 15, 16 }


/* Stack probes */

#define MASK_PROBE		000100000000	/* Generate stack probes */

#undef SUBTARGET_SWITCHES
#define SUBTARGET_SWITCHES  \
    { "probe", MASK_PROBE},				\
    { "no-probe", -MASK_PROBE},

/* Use a stack probe */
#define TARGET_PROBE (target_flags & MASK_PROBE)

#define PROBE_SIZE         0x1000
#define PROBE_MAX_INLINE   0x10000

/* Output assembler code to FILE to increment profiler label # LABELNO
   for profiling a function entry.  */

#undef FUNCTION_PROFILER
#define FUNCTION_PROFILER(FILE, LABELNO)  \
{									\
  fprintf (FILE, "\tpushl $%sP%d\n", LPREFIX, (LABELNO));		\
  fprintf (FILE, "\tcall __mcount\n");					\
  fprintf (FILE, "\taddl $4,%%esp\n");					\
}

#define PROFILE_BEFORE_PROLOGUE
